
//`#start header` -- edit after this line, do not edit this line
// ========================================
//
// Copyright YOUR COMPANY, THE YEAR
// All Rights Reserved
// UNPUBLISHED, LICENSED SOFTWARE.
//
// CONFIDENTIAL AND PROPRIETARY INFORMATION
// WHICH IS THE PROPERTY OF your company.
//
// ========================================
`include "cypress.v"
//`#end` -- edit above this line, do not edit this line
// Generated on 07/31/2018 at 13:40
// Component: IBUS_Unit
module IBUS_Unit (
	output [3:0] AddressO,
	inout [7:0] DataO,
	output  DSnO,
	output  interrupt,
	output  RDnWRO,
	inout  [7:0] DataI,
	input  [3:0] AddressI,
	input   clk,
	input   DSnI,
	input   RDnWRI,
	input   reset
);

//`#start body` -- edit after this line, do not edit this line
`define P0 4'd0
`define P1 4'd1
`define P2 4'd2
`define P3 4'd3
`define P4 4'd4
`define P5 4'd5
`define P6 4'd6

/********************Address gating*******************************/
// in order to achieve a working synthesis, we need to gate the incoming address signals
// otherwise the synthesiser treats them as asynchronous signals and digital placement fails. Miserably
reg [3:0] addr;
always @ (posedge clk or posedge reset)
    if(reset)
        addr <= 4'hF;
    else
        addr <= AddressI;
        
// Also, we transparently forward the address        
assign AddressO = addr;

/********************Data REG*******************************/

wire [7:0]  pbv_0,
            pbv_1,
            pbv_2,
            pbv_3,
            pbv_4,
            mob_5,
            mob_6;

// PBV_0
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myPBV0(
/* output [07:00] */ .control(pbv_0),
/* input          */ .clock(clk)
);

// PBV_1
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myPBV1(
/* output [07:00] */ .control(pbv_1),
/* input          */ .clock(clk)
);

// PBV_2
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myPBV2(
/* output [07:00] */ .control(pbv_2),
/* input          */ .clock(clk)
);

// PBV_3
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myPBV3(
/* output [07:00] */ .control(pbv_3),
/* input          */ .clock(clk)
);

// PBV_4
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myPBV4(
/* output [07:00] */ .control(pbv_4),
/* input          */ .clock(clk)
);

// MOB_5
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myMOB5(
/* output [07:00] */ .control(mob_5),
/* input          */ .clock(clk)
);

// MOB_6
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
myMOB6(
/* output [07:00] */ .control(mob_6),
/* input          */ .clock(clk)
);

/********************Mask REG*******************************/
wire [7:0]  pbv_0_mask,
            pbv_1_mask,
            pbv_2_mask,
            pbv_3_mask,
            pbv_4_mask,
            mob_5_mask,
            mob_6_mask;

// PBV_0_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskPBV0(
/* output [07:00] */ .control(pbv_0_mask),
/* input          */ .clock(clk)
);

// PBV_1_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskPBV1(
/* output [07:00] */ .control(pbv_1_mask),
/* input          */ .clock(clk)
);

// PBV_2_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskPBV2(
/* output [07:00] */ .control(pbv_2_mask),
/* input          */ .clock(clk)
);

// PBV_3_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskPBV3(
/* output [07:00] */ .control(pbv_3_mask),
/* input          */ .clock(clk)
);

// PBV_4_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskPBV4(
/* output [07:00] */ .control(pbv_4_mask),
/* input          */ .clock(clk)
);

// MOB_5_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskMOB5(
/* output [07:00] */ .control(mob_5_mask),
/* input          */ .clock(clk)
);

// MOB_6_mask
cy_psoc3_control #(.cy_init_value (8'b00000000), .cy_force_order(`TRUE), .cy_ctrl_mode_1(8'b0000_0000), .cy_ctrl_mode_0(8'b1111_1111))
maskMOB6(
/* output [07:00] */ .control(mob_6_mask),
/* input          */ .clock(clk)
);

/******************** OUTPUT GENERATION *******************************/
// The output is switched in a bit-wise fashion. The mask bit selects
// whether the databit or the registered bit is driven to the output

// bufdata holds the value from the Slave (CPLD) during a reading cycle
// register for the din data
reg  [7:0]  bufreg;
reg  [7:0]  bufmask;
reg  [7:0]  bufdat;
wire [7:0]  din;
wire [7:0]  dout;

// BUFREG
always @ (posedge clk or posedge reset)
    if(reset)
        bufreg <= 'b0;
    else if(!DSnI && RDnWRI)
        bufreg <= din;
    else
        bufreg <= bufreg;
		
// BUFMASK & BUFDAT        
always @ (posedge clk)
    case(addr)
        `P0:
        begin
            bufmask <= pbv_0_mask;
            bufdat  <= pbv_0;
        end
        
        `P1:
        begin
            bufmask <= pbv_1_mask;
            bufdat  <= pbv_1;
        end
        
        `P2:
        begin
            bufmask <= pbv_2_mask;
            bufdat  <= pbv_2;
        end
        
        `P3:
        begin
            bufmask <= pbv_3_mask;
            bufdat  <= pbv_3;
        end
        
        `P4:
        begin
            bufmask <= pbv_4_mask;
            bufdat  <= pbv_4;
        end
        
        `P5:
        begin
            bufmask <= mob_5_mask;
            bufdat  <= mob_5;
        end
        
        `P6:
        begin
            bufmask <= mob_6_mask;
            bufdat  <= mob_6;
        end
        
        default:
        begin
            bufmask <= bufmask;
            bufdat <= bufdat;
        end
    endcase //address decode

// OUTPUT GENERATION
assign dout[7] =    bufmask[7] ? bufdat[7] : bufreg[7];
assign dout[6] =    bufmask[6] ? bufdat[6] : bufreg[6];
assign dout[5] =    bufmask[5] ? bufdat[5] : bufreg[5];
assign dout[4] =    bufmask[4] ? bufdat[4] : bufreg[4];
assign dout[3] =    bufmask[3] ? bufdat[3] : bufreg[3];
assign dout[2] =    bufmask[2] ? bufdat[2] : bufreg[2];
assign dout[1] =    bufmask[1] ? bufdat[1] : bufreg[1];
assign dout[0] =    bufmask[0] ? bufdat[0] : bufreg[0];

/********************DATA-STROBE********************************/

assign DSnO = DSnI;

/******************** R / W ********************************/

assign RDnWRO = RDnWRI;
    
/********************INTERRUPT********************************/
// interrupt for the end of each read cycle
assign interrupt = (DSnI && RDnWRI);

/********************BUFOE MODULES********************************/
// INOUT Buf needs an output enable signal. OE should be active if the slave is being read and the Data Strobe_n is active (LOW)            
// IF OE == '1' -> y == x (== yfb); IF OE == '0' -> yfb == y (HiZ)
wire [7:0] write;
wire oe_i;
wire oe_o;
assign oe_i = (RDnWRI && !DSnI) ? 1 : 0 ;
assign oe_o = ~oe_i;


    cy_bufoe datai_0 (
        .x(dout[0]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[0]),        // (inout) Connect to the bidirectional pin
        .yfb(write[0]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_1 (
        .x(dout[1]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[1]),        // (inout) Connect to the bidirectional pin
        .yfb(write[1]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_2 (
        .x(dout[2]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[2]),        // (inout) Connect to the bidirectional pin
        .yfb(write[2]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_3 (
        .x(dout[3]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[3]),        // (inout) Connect to the bidirectional pin
        .yfb(write[3]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_4 (
        .x(dout[4]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[4]),        // (inout) Connect to the bidirectional pin
        .yfb(write[4]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_5 (
        .x(dout[5]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[5]),        // (inout) Connect to the bidirectional pin
        .yfb(write[5]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_6 (
        .x(dout[6]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[6]),        // (inout) Connect to the bidirectional pin
        .yfb(write[6]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datai_7 (
        .x(dout[7]),        // (input) Value to send out
        .oe(oe_i),            // (input) Output Enable
        .y(DataI[7]),        // (inout) Connect to the bidirectional pin
        .yfb(write[7]));      // (ouptut) Value on the pin brought back in
        
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        
    cy_bufoe datao_0 (
        .x(write[0]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[0]),        // (inout) Connect to the bidirectional pin
        .yfb(din[0]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_1 (
        .x(write[1]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[1]),        // (inout) Connect to the bidirectional pin
        .yfb(din[1]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_2 (
        .x(write[2]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[2]),        // (inout) Connect to the bidirectional pin
        .yfb(din[2]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_3 (
        .x(write[3]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[3]),        // (inout) Connect to the bidirectional pin
        .yfb(din[3]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_4 (
        .x(write[4]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[4]),        // (inout) Connect to the bidirectional pin
        .yfb(din[4]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_5 (
        .x(write[5]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[5]),        // (inout) Connect to the bidirectional pin
        .yfb(din[5]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_6 (
        .x(write[6]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[6]),        // (inout) Connect to the bidirectional pin
        .yfb(din[6]));      // (ouptut) Value on the pin brought back in
        
    cy_bufoe datao_7 (
        .x(write[7]),        // (input) Value to send out
        .oe(oe_o),            // (input) Output Enable
        .y(DataO[7]),        // (inout) Connect to the bidirectional pin
        .yfb(din[7]));      // (ouptut) Value on the pin brought back in

//`#end` -- edit above this line, do not edit this line
endmodule
//`#start footer` -- edit after this line, do not edit this line
//`#end` -- edit above this line, do not edit this line
